//+------------------------------------------------------------------+ 
//| CALCOLO LOTTI POSIZIONI LUNGHE CON FIXED FRACTIONAL METHOD       |                                           | 
//+------------------------------------------------------------------+ 

double Lots_Long_Euro()
       {   
       if ((Symbol() == "EURUSD") || (Symbol() == "GBPUSD") || (Symbol() == "AUDUSD") || (Symbol() == "NZDUSD") )
         {
         Potential_Loss_Long = Distanza_Long*100000 ; 
         }
       else if ((Symbol() == "USDJPY") || (Symbol() == "EURJPY"))
         {
         Potential_Loss_Long = (Distanza_Long*100000)/MarketInfo("USDJPY",MODE_BID) ;
         }
       else if ((Symbol() == "USDCHF") || (Symbol() == "EURCHF"))
         {
         Potential_Loss_Long = (Distanza_Long*100000)/MarketInfo("USDCHF",MODE_BID) ;
         }  
       else if ((Symbol() == "EURGBP"))
         {
         Potential_Loss_Long = (Distanza_Long*100000)/(1/MarketInfo("GBPUSD",MODE_BID)) ;
         }    
       else if ((Symbol() == "USDCAD"))
         {
         Potential_Loss_Long = (Distanza_Long*100000/MarketInfo("USDCAD",MODE_BID)) ; 
         }
       else if ((Symbol() == "XAUUSD"))
         {
         Potential_Loss_Long =  Distanza_Long*100 ; 
         }
       else if ((Symbol() == "XAGUSD"))
         {
         Potential_Loss_Long =  Distanza_Long*5000 ; 
         }  
      
       Lots_Long = (AccountFreeMargin()*MarketInfo("EURUSD",MODE_ASK)*Risk/100) / Potential_Loss_Long ;
       
       if(Lots_Long<0.01) 
         {
         Lots_Long = 0;
         }
         else
         {
         Lots_Long = NormalizeDouble(Lots_Long,2); 
         }    
           
       return(Lots_Long);
       Print(Lots_Long);
       }