//+------------------------------------------------------------------+ 
//| Renko Bierovic Weekly - ALBERTO TORTELLA                         | 
//+------------------------------------------------------------------+ 

// CARATTERISTICHE
// ENTRATA SU ROTTURA MIN/MAX BARRA PRECEDENTE
// TREND IN ATTO IN BASE A MEDIE MOBILI E DMI SPREAD
// RITRACCIAMENTO FIBONACCI SETTABILE A PIACERE
// STOP LATO OPPOSTO DEL PATTERN
// TRAILING STOP MIN/MAX ULTIME 2 BARRE
// TARGET GIORNALIERO e TARGET SETTIMANALE SETTABILE a PIACERE

//+------------------------------------------------------------------+ 
//| IMPOSTAZIONE VARIABILI ESTERNE                                   | 
//+------------------------------------------------------------------+ 

extern int    Filter_In   = 10   ; // filtro da aggiungere al livello di breakout
extern int    Filter_Out  = 20   ; // filtro da aggiungere al livello di stop
extern int    Fast_Ema    =  9   ; // media mobile veloce
extern int    Slow_Ema    = 18   ; // media mobile lenta
extern int    DMI         = 15   ; // forza del trend misurata dal DMI Spread
extern int    Fractal     =  3   ; // calcolo frattali
extern double Risk        =  0.5 ; // rischio massimo accettabile su ogni trade
extern double Fibo_1      = 23.6 ; // percentuale di ritracciamento minimo
extern double Ratio       =  1.5 ; // rapporto risk reward che si vuole ottenere
extern double Daily_Gain  =  5.0 ; // guadagno giornaliero % atteso
extern double Weekly_Gain = 12.5 ; // guadagno settimanale % atteso


//+------------------------------------------------------------------+ 
//| IMPOSTAZIONE VARIABILI INTERNE                                   | 
//+------------------------------------------------------------------+ 

int  Num_Order_Long, Num_Order_Short, Lotti, Barre ;
bool Long, Short ;
bool Setup_Long_1, Setup_Long_2, Entry_Long_1, Entry_Long_2, Entry_Long ;
bool Setup_Short_1, Setup_Short_2, Entry_Short_1, Entry_Short_2, Entry_Short ;
bool Trend_Long, Trend_Short;
double Take_Profit_Long, Take_Profit_Short ;

bool can_trade_long_1  = false ; // variabile di controllo per prima tranche long
bool can_trade_short_1 = false ; // variabile di controllo per seconda tranche long

bool can_trade_long_2  = false ; // variabile di controllo per prima tranche long
bool can_trade_short_2 = false ; // variabile di controllo per seconda tranche short

bool can_trade_long_3  = false ; // variabile di controllo per prima tranche long
bool can_trade_short_3 = false ; // variabile di controllo per seconda tranche long

bool can_trade_long_4  = false ; // variabile di controllo per prima tranche long
bool can_trade_short_4 = false ; // variabile di controllo per seconda tranche short

bool BULL_CROSS        = false ; // variabiel di controllo incrocio medie mobili
bool BEAR_CROSS        = false ; // variabiel di controllo incrocio medie mobili


double Distanza_Long, Distanza_Short, Account ;   
double Retrace_Long_1, Retrace_Short_1 ;
double Retrace_Long_2, Retrace_Short_2 ;
double Potential_Loss_Long, Potential_Loss_Short, Punto ; 
double Spread, pipValue, Lots, Apertura, Trailing_Stop ;
double Fast_Ema_1, Slow_Ema_1, Fast_Ema_2, Slow_Ema_2, Fast_Ema_3, Slow_Ema_3 ;
double Min_Stop, Stop_Long, Stop_Short;
double Perdita_Long, Perdita_Short;
double Stop_Long_5M, Stop_Short_5M, New_Stop ;
double Initial_Size;
double i, j;
double Lots_Long, Lots_Short;
double Fractal_U, Fractal_D ;
int    a = 0, Contatore, m ;
 
int Ora_Entrata, cnt, total, ticket_long, ticket_short;
double lotStep;

bool First_Prize_Long, First_Prize_Short, R2D2_Long, R2D2_Short ;

//+------------------------------------------------------------------+ 
//| RICHIAMO FILES ESTERNI                                           |                                              
//+------------------------------------------------------------------+ 

#include <Punto.mqh>            // adattamento per 5 decimali
#include <Lots_Long_Euro.mqh>   // Fixed Fractional Method su posizioni lunghe
#include <Lots_Short_Euro.mqh>  // Fixed Fractional Method su posizioni lunghe
#include <HOUR.mqh>             // Controlla le fasce orarie per poter opeare

#include <DMI_UP_2.mqh>        // calcola valore DMI Spread su ultimo Fractal Up
#include <DMI_DOWN_2.mqh>      // calcola valore DMI Spread su ultimo Fractal Down

#include <BULL_CROSS.mqh>    // calcola valore DMI Spread su ultimo Fractal Up
#include <BEAR_CROSS.mqh>    // calcola valore DMI Spread su ultimo Fractal Down

#include <START_UP.mqh>      // calcola il minimo  sulla partenza del rialzo
#include <START_DOWN.mqh>    // calcola il massimo sulla partenza del ribasso

 
int start() 
  { 



//+------------------------------------------------------------------+ 
//| CALCOLO TARGET GIORNALIERO e SETTIMANALE                         |                                              
//+------------------------------------------------------------------+  


   if (Symbol()=="EURUSD" && Hour()==10 && Minute()==0 && m==0)
     {
     GlobalVariableSet("Initial_Account",AccountBalance()); 
     GlobalVariableSet("Target_daily",AccountBalance()*Daily_Gain/100); 
     GlobalVariableSet("Target_Account",GlobalVariableGet("Initial_Account")+GlobalVariableGet("Target_daily")); 
     Print("Saldo iniziale  : ", GlobalVariableGet("Initial_Account"));
     Print("Guadagno atteso  : ", GlobalVariableGet("Target_daily"));
     Print("Saldo finale atteso  : ", GlobalVariableGet("Target_Account"));
     m=1 ;
     }        

   if (Symbol()=="EURUSD" && DayOfWeek()==1 && Hour()==10 && Minute()==0 && m==0)
     {
     GlobalVariableSet("Target_weekly",AccountBalance()*Weekly_Gain/100); 
     GlobalVariableSet("Weekly_Target_Account",GlobalVariableGet("Initial_Account")+GlobalVariableGet("Target_weekly")); 
     Print("Guadagno atteso setttimanale  : ", GlobalVariableGet("Target_weekly"));
     Print("Saldo finale atteso settimanale  : ", GlobalVariableGet("Weekly_Target_Account"));
     m=1 ;
     }          
        
  if (Minute()==1)
     {
     m=0 ;
     }   
     
//+------------------------------------------------------------------+ 
//| CONTROLLO DELLE POSIZIONI APERTE                                 |                                              
//+------------------------------------------------------------------+      


// SE CAMBIA LA BARRA RESETTO LA VARIABILE "NO TRADE" 
if (Apertura != Open[0]) 
        {
        a=0;
        }          

// CONTROLLO CHE NON CI SIANO ORDINI APERTI SU QUESTO CROSS 
// PER LA PRIMA SIZE DI OGNI STRATEGIA
  
  total = OrdersTotal();
  Num_Order_Long  = 0;
  Num_Order_Short = 0;
  
  for(cnt=0;cnt<=total;cnt++)
     {
     OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
     if (
         OrderSymbol()==Symbol() && 
        (OrderMagicNumber()==1 || OrderMagicNumber()==2  || OrderMagicNumber()==3 || OrderMagicNumber()==4  || OrderMagicNumber()==5  || OrderMagicNumber()==6 
      || OrderMagicNumber()==7 || OrderMagicNumber()==8  || OrderMagicNumber()==9 || OrderMagicNumber()==10 || OrderMagicNumber()==11 || OrderMagicNumber()==12 )
        )
        {  // Controlla il cross e l'expert che ha aperto la posizione
        if (OrderType()==OP_BUY)
           { 
           Num_Order_Long++;
           }
        if (OrderType()==OP_SELL)
           { 
           Num_Order_Short++;
           }   
        }  
     }    

  if( Num_Order_Long==0 && AccountEquity()<GlobalVariableGet("Target_Account") && AccountEquity()<GlobalVariableGet("Weekly_Target_Account")  )
    { 
    can_trade_long_1  = true;
    } 
  if( Num_Order_Short==0 && AccountEquity()<GlobalVariableGet("Target_Account") && AccountEquity()<GlobalVariableGet("Weekly_Target_Account") )
    { 
    can_trade_short_1 = true;
    }  

// CONTROLLO CHE NON CI SIANO ORDINI APERTI SU QUESTO CROSS 
// PER LA PRIMA SIZE DI OGNI STRATEGIA
  
  total = OrdersTotal();
  Num_Order_Long  = 0;
  Num_Order_Short = 0;
  
  for(cnt=0;cnt<=total;cnt++)
     {
     OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
     if (
         OrderSymbol()==Symbol() && 
        (OrderMagicNumber()==2  || OrderMagicNumber()==4 || OrderMagicNumber()==6 || OrderMagicNumber()==8
      || OrderMagicNumber()==10 || OrderMagicNumber()==12 )
        ) 
        {  // Controlla il cross e l'expert che ha aperto la posizione
        if (OrderType()==OP_BUY)
           { 
           Num_Order_Long++;
           }
        if (OrderType()==OP_SELL)
           { 
           Num_Order_Short++;
           }   
        }  
     }    

  if( Num_Order_Long==0 && AccountEquity()<GlobalVariableGet("Target_Account") && AccountEquity()<GlobalVariableGet("Weekly_Target_Account")  )
    { 
    can_trade_long_2  = true;
    } 
  if( Num_Order_Short==0 && AccountEquity()<GlobalVariableGet("Target_Account") && AccountEquity()<GlobalVariableGet("Weekly_Target_Account") )
    { 
    can_trade_short_2 = true;
    }  



//+------------------------------------------------------------------+ 
//| PRICE ACTION                                                     |                                             
//+------------------------------------------------------------------+ 


Fast_Ema_1 = iMA(NULL,NULL,Fast_Ema,0,MODE_EMA,PRICE_CLOSE,1) ;
Slow_Ema_1 = iMA(NULL,NULL,Slow_Ema,0,MODE_EMA,PRICE_CLOSE,1) ;
Fast_Ema_2 = iMA(NULL,NULL,Fast_Ema,0,MODE_EMA,PRICE_CLOSE,2) ;
Slow_Ema_2 = iMA(NULL,NULL,Slow_Ema,0,MODE_EMA,PRICE_CLOSE,2) ;
Fast_Ema_3 = iMA(NULL,NULL,Fast_Ema,0,MODE_EMA,PRICE_CLOSE,3) ;
Slow_Ema_3 = iMA(NULL,NULL,Slow_Ema,0,MODE_EMA,PRICE_CLOSE,3) ;

bool Price_Action_Long_1  = Close[1]<Open[1] && Bid>=Open[1]+Filter_In/Punto() ; // FIRST PRIZE

bool Price_Action_Long_2  = (Close[1]<Fast_Ema_1 || Low[0]<Fast_Ema_1) && Close[2]>Slow_Ema_2 && Close[3]>Slow_Ema_3 && Close[1]<Open[1] && Bid>=Open[1]+Filter_In/Punto() ; // R2D2

bool Price_Action_Short_1 = Close[1]>Open[1] && Bid<=Open[1]-Filter_In/Punto() ; // FIRST PRIZE

bool Price_Action_Short_2 = (Close[1]>Fast_Ema_1 || High[0]>Fast_Ema_1) && Close[2]<Slow_Ema_2 && Close[3]<Slow_Ema_3 && Close[1]>Open[1] && Bid<=Open[1]-Filter_In/Punto() ; // R2D2


//+------------------------------------------------------------------+ 
//| SET UP                                                           |                                             
//+------------------------------------------------------------------+ 

Retrace_Long_1  = High[iHighest(NULL,0,MODE_HIGH,2,1)] - (High[iHighest(NULL,0,MODE_HIGH,2,1)] - START_UP() ) * Fibo_1/100 ;
Retrace_Short_1 = Low[iLowest(NULL,0,MODE_LOW,2,1)]    + (START_DOWN() - Low[iLowest(NULL,0,MODE_LOW,2,1)]  ) * Fibo_1/100 ;

double Fractal_Up   = iCustom(NULL,NULL,"FractalLevels",Fractal,0,1) ;
double Fractal_Down = iCustom(NULL,NULL,"FractalLevels",Fractal,1,1) ;

// =================================================================================================================  


First_Prize_Long  =  iCustom(NULL,NULL,"DMI Spread",13,0,1) >= DMI   // forza del trend
                  && (Low[0]<Retrace_Long_1 || Low[1]<Retrace_Long_1) // ritracciamento minimo
                  && Bid > Fractal_Down // supporto rispettato 
                  && Fast_Ema_1>Slow_Ema_1 && Fast_Ema_2>Slow_Ema_2  // trend confermato da medie
                  && BULL_CROSS() ; // incorcio al rialzo durante l'ultima onda rialzista
                               
R2D2_Long        = DMI_UP_2() >= DMI   // forza del trend
                && iCustom(NULL,NULL,"DMI Spread",13,0,1) > -DMI // check forza del retrace
                && iCustom(NULL,NULL,"DMI Spread",13,0,2) > -DMI // check forza del retrace
                && Bid > Fractal_Down // supporto rispettato 
                && (Fast_Ema_1>Slow_Ema_1 || Fast_Ema_2>Slow_Ema_2) ; // trend confermato da medie                   
                                                         
Entry_Long_1    = First_Prize_Long && Price_Action_Long_1 ;  

Entry_Long_2    = R2D2_Long && Price_Action_Long_2 ;  

// =================================================================================================================  
                
First_Prize_Short  =   iCustom(NULL,NULL,"DMI Spread",13,0,1) <= -DMI   // forza del trend
                && (High[0]>Retrace_Short_1 || High[1]>Retrace_Short_1) // ritracciamento minimo
                && Bid < Fractal_Up // resistenza rispettata
                && Fast_Ema_1<Slow_Ema_1 && Fast_Ema_2<Slow_Ema_2  // trend confermato da medie
                && BEAR_CROSS() ; // incorcio al ribasso durante l'ultima onda rialzista
                              
R2D2_Short       = DMI_DOWN_2() <= -DMI   // forza del trend
                && iCustom(NULL,NULL,"DMI Spread",13,0,1) < DMI // check forza del retrace
                && iCustom(NULL,NULL,"DMI Spread",13,0,2) < DMI // check forza del retrace
                && Bid < Fractal_Down // supporto rispettato 
                && (Fast_Ema_1<Slow_Ema_1 || Fast_Ema_2<Slow_Ema_2) ; // trend confermato da medie                            
                                                  
Entry_Short_1   = First_Prize_Short && Price_Action_Short_1 ;  

Entry_Short_2   = R2D2_Short && Price_Action_Short_2 ;                  
  

//+------------------------------------------------------------------+ 
//| APERTURA POSIZIONI  FIRST PRIZE                                  |                                             
//+------------------------------------------------------------------+


// POSIZIONI LONG CON TAKE PROFIT

if(Entry_Long_1 && can_trade_long_1 && HOUR()==1)  
  { 
  Min_Stop         = Bid-MarketInfo(Symbol(),MODE_STOPLEVEL)/Punto() ;
  Stop_Long        = MathMin(Low[0],Low[1])-Filter_Out/Punto() ;
  Distanza_Long    = Ask - Stop_Long ; 
  Take_Profit_Long = Ask + (Distanza_Long*Ratio) ;
    
  Lots_Long        = Lots_Long_Euro();
  Initial_Size     = Lots_Long ; 
  Account          = AccountFreeMargin();
  
  if (Lots_Long>=0.01)               
     {    
     ticket_long = OrderSend(Symbol(),OP_BUY,Lots_Long,Ask,NULL,Stop_Long,Take_Profit_Long,"First Prize Long",1,0,Green) ;       
                           
     if(ticket_long>0) 
       { 
       if(OrderSelect(ticket_long,SELECT_BY_TICKET,MODE_TRADES))
         {
         Print("1%  ", AccountFreeMargin()*Risk) ;
         Perdita_Long = OrderOpenPrice()-Stop_Long ;
         Print("Loss Potenziale  ", Perdita_Long*Punto()/10," pips");
         Print("Perdita potenziale  : ", ( Perdita_Long*Punto()*Lots_Long)/MarketInfo("EURUSD",MODE_ASK)," Euro"); 
         Print("Perdita potenziale  : ", ((Perdita_Long*Punto()*Lots_Long)/Account*100)/MarketInfo("EURUSD",MODE_ASK),"% del conto"); 
         Print("Take Profit Long  : ", Take_Profit_Long);
                                 
         can_trade_long_1 = false;
         Barre = Bars ;
         Apertura = Open[0];
               
         int handle=FileOpen("Trend.csv", FILE_CSV|FILE_READ|FILE_WRITE, ';');
         if(handle>0)
           {
           FileSeek(handle, 0, SEEK_END);
           //---- add data to the end of file
           FileWrite(handle,OrderSymbol(),TimeToStr(OrderOpenTime()),Stop_Long);
           FileClose(handle);
           handle=0;
           }
         }
       else Print("Error opening BUY order: ",GetLastError()); 
       return(0); 
       }               
     }
  else if (a == 0)
     {
     Print("No trade man!");
     a = 1;
     Apertura = Open[0];
     }
  }
  


// POSIZIONI LONG SENZA TAKE PROFIT

if(Entry_Long_1 && can_trade_long_2 && HOUR()==1)  
  { 
  Min_Stop         = Bid-MarketInfo(Symbol(),MODE_STOPLEVEL)/Punto() ;
  Stop_Long        = MathMin(Low[0],Low[1])-Filter_Out/Punto() ;
  Distanza_Long    = Ask - Stop_Long ; 
  
  Lots_Long        = Lots_Long_Euro(); 
  Initial_Size     = Lots_Long ; 
  Account          = AccountFreeMargin();
  
  if (Lots_Long>=0.01)               
     {    
     ticket_long = OrderSend(Symbol(),OP_BUY,Lots_Long,Ask,NULL,Stop_Long,NULL,"First Prize Long",2,0,Green) ;    
                           
     if(ticket_long>0) 
       { 
       if(OrderSelect(ticket_long,SELECT_BY_TICKET,MODE_TRADES))
         {
         Print("1%  ", AccountFreeMargin()*Risk) ;
         Perdita_Long = OrderOpenPrice()-Stop_Long ;
         Print("Loss Potenziale  ", Perdita_Long*Punto()/10," pips");
         Print("Perdita potenziale  : ", ( Perdita_Long*Punto()*Lots_Long)/MarketInfo("EURUSD",MODE_ASK)," Euro"); 
         Print("Perdita potenziale  : ", ((Perdita_Long*Punto()*Lots_Long)/Account*100)/MarketInfo("EURUSD",MODE_ASK),"% del conto"); 
         Print("Take Profit Long  : ", Take_Profit_Long);
                                
         can_trade_long_2 = false;
         Barre = Bars ;
         Apertura = Open[0];
               
         int handle_3=FileOpen("Trend.csv", FILE_CSV|FILE_READ|FILE_WRITE, ';');
         if(handle_3>0)
           {
           FileSeek(handle_3, 0, SEEK_END);
           //---- add data to the end of file
           FileWrite(handle_3,OrderSymbol(),TimeToStr(OrderOpenTime()),Stop_Long);
           FileClose(handle_3);
           handle_3=0;
           }
         }
       else Print("Error opening BUY order: ",GetLastError()); 
       return(0); 
       }               
     }
  else if (a == 0)
     {
     Print("No trade man!");
     a = 1;
     Apertura = Open[0];
     }
  }

// POSIZIONI SHORT CON TAKE PROFIT
 
 
if(Entry_Short_1 && can_trade_short_1 && HOUR()==1)  
  {    
  Spread            = Ask - Bid ;
  Min_Stop          = Bid+MarketInfo(Symbol(),MODE_STOPLEVEL)/Punto() + Spread ;
  Stop_Short        = MathMax(High[0],High[1])+Filter_Out/Punto()+Spread  ;
  Distanza_Short    = Stop_Short - Bid ;
  Take_Profit_Short = Bid-(Distanza_Short*Ratio) ;    
  Lots_Short        = Lots_Short_Euro();  
  Initial_Size      = Lots_Short ; 
  Account           = AccountFreeMargin();                  
  
  if (Lots_Short>=0.01)                
     { 
     ticket_short = OrderSend(Symbol(),OP_SELL,Lots_Short,Bid,NULL,Stop_Short,Take_Profit_Short,"First Prize Short",3,0,Red) ;                           
     
     if(ticket_short>0) 
       { 
       if(OrderSelect(ticket_short,SELECT_BY_TICKET,MODE_TRADES))
       {
       Print("1%  ", AccountFreeMargin()*Risk);
       Perdita_Short = Stop_Short-OrderOpenPrice() ;
       Print("Loss Potenziale  ", Perdita_Short*Punto()/10," pips");
       Print("Perdita potenziale  : ", ( Perdita_Short*Punto()*Lots_Short)/MarketInfo("EURUSD",MODE_BID)," Euro");
       Print("Perdita potenziale  : ", ((Perdita_Short*Punto()*Lots_Short)/Account*100)/MarketInfo("EURUSD",MODE_BID),"% del conto");
       Print("Take Profit Short  : ", Take_Profit_Short);
              
       can_trade_short_1 = false;
       Barre = Bars ;
       Apertura = Open[0];
       
       int handle_2=FileOpen("Trend.csv", FILE_CSV|FILE_READ|FILE_WRITE, ';');
       if(handle_2>0)
           {
           FileSeek(handle_2, 0, SEEK_END);
           //---- add data to the end of file
           FileWrite(handle_2,OrderSymbol(),TimeToStr(OrderOpenTime()),Stop_Short);
           FileClose(handle_2);
           handle_2=0;
           }    
     
       }
       else Print("Error opening SELL order : ",GetLastError()); 
       return(0); 
       }
     }  
  else if (a == 0)
     {
     Print("No trade man!");
     a = 1;
     Apertura = Open[0];
     }
  }
  

// POSIZIONI SHORT SENZA TAKE PROFIT
 
 
if(Entry_Short_1 && can_trade_short_2 && HOUR()==1)  
  {    
  Spread            = Ask - Bid ;
  Min_Stop          = Bid+MarketInfo(Symbol(),MODE_STOPLEVEL)/Punto() + Spread ;
  Stop_Short        = MathMax(High[0],High[1])+Filter_Out/Punto()+Spread  ;
  Distanza_Short    = Stop_Short - Bid ;
  Take_Profit_Short = Bid-(Distanza_Short*Ratio) ;    
  Lots_Short        = Lots_Short_Euro();  
  Initial_Size      = Lots_Short ; 
  Account           = AccountFreeMargin();                 
  
  if (Lots_Short>=0.01)                
     { 
     ticket_short = OrderSend(Symbol(),OP_SELL,Lots_Short,Bid,NULL,Stop_Short,NULL,"First Prize Short",4,0,Red) ;                         
     
     if(ticket_short>0) 
       { 
       if(OrderSelect(ticket_short,SELECT_BY_TICKET,MODE_TRADES))
       {
       Print("1%  ", AccountFreeMargin()*Risk);
       Perdita_Short = Stop_Short-OrderOpenPrice() ;
       Print("Loss Potenziale  ", Perdita_Short*Punto()/10," pips");
       Print("Perdita potenziale  : ", ( Perdita_Short*Punto()*Lots_Short)/MarketInfo("EURUSD",MODE_BID)," Euro");
       Print("Perdita potenziale  : ", ((Perdita_Short*Punto()*Lots_Short)/Account*100)/MarketInfo("EURUSD",MODE_BID),"% del conto");
       Print("Take Profit Short  : ", Take_Profit_Short);
              
       can_trade_short_2 = false;
       Barre = Bars ;
       Apertura = Open[0];
       
       int handle_4=FileOpen("Trend.csv", FILE_CSV|FILE_READ|FILE_WRITE, ';');
       if(handle_4>0)
           {
           FileSeek(handle_4, 0, SEEK_END);
           //---- add data to the end of file
           FileWrite(handle_4,OrderSymbol(),TimeToStr(OrderOpenTime()),Stop_Short);
           FileClose(handle_4);
           handle_4=0;
           }    
     
       }
       else Print("Error opening SELL order : ",GetLastError()); 
       return(0); 
       }
     }  
  else if (a == 0)
     {
     Print("No trade man!");
     a = 1;
     Apertura = Open[0];
     }
  }



//+------------------------------------------------------------------+ 
//| APERTURA POSIZIONI  R2D2                                         |                                             
//+------------------------------------------------------------------+


// POSIZIONI LONG CON TAKE PROFIT

if(Entry_Long_2 && can_trade_long_1 && HOUR()==1)  
  { 
  Min_Stop         = Bid-MarketInfo(Symbol(),MODE_STOPLEVEL)/Punto() ;
  Stop_Long        = MathMin(Low[0],Low[1])-Filter_Out/Punto() ;
  Distanza_Long    = Ask - Stop_Long ; 
  Take_Profit_Long = Ask + (Distanza_Long*Ratio) ;
    
  Lots_Long        = Lots_Long_Euro();
  Initial_Size     = Lots_Long ; 
  Account          = AccountFreeMargin();
  
  if (Lots_Long>=0.01)               
     {    
     ticket_long = OrderSend(Symbol(),OP_BUY,Lots_Long,Ask,NULL,Stop_Long,Take_Profit_Long,"R2D2 Long",5,0,Green) ;       
                           
     if(ticket_long>0) 
       { 
       if(OrderSelect(ticket_long,SELECT_BY_TICKET,MODE_TRADES))
         {
         Print("1%  ", AccountFreeMargin()*Risk) ;
         Perdita_Long = OrderOpenPrice()-Stop_Long ;
         Print("Loss Potenziale  ", Perdita_Long*Punto()/10," pips");
         Print("Perdita potenziale  : ", ( Perdita_Long*Punto()*Lots_Long)/MarketInfo("EURUSD",MODE_ASK)," Euro"); 
         Print("Perdita potenziale  : ", ((Perdita_Long*Punto()*Lots_Long)/Account*100)/MarketInfo("EURUSD",MODE_ASK),"% del conto"); 
         Print("Take Profit Long  : ", Take_Profit_Long);
                                 
         can_trade_long_1 = false;
         Barre = Bars ;
         Apertura = Open[0];
               
         int handle_5=FileOpen("Trend.csv", FILE_CSV|FILE_READ|FILE_WRITE, ';');
         if(handle_5>0)
           {
           FileSeek(handle_5, 0, SEEK_END);
           //---- add data to the end of file
           FileWrite(handle_5,OrderSymbol(),TimeToStr(OrderOpenTime()),Stop_Long);
           FileClose(handle_5);
           handle_5=0;
           }
         }
       else Print("Error opening BUY order: ",GetLastError()); 
       return(0); 
       }               
     }
  else if (a == 0)
     {
     Print("No trade man!");
     a = 1;
     Apertura = Open[0];
     }
  }
  


// POSIZIONI LONG SENZA TAKE PROFIT

if(Entry_Long_2 && can_trade_long_2 && HOUR()==1)  
  { 
  Min_Stop         = Bid-MarketInfo(Symbol(),MODE_STOPLEVEL)/Punto() ;
  Stop_Long        = MathMin(Low[0],Low[1])-Filter_Out/Punto() ;
  Distanza_Long    = Ask - Stop_Long ; 
  
  Lots_Long        = Lots_Long_Euro(); 
  Initial_Size     = Lots_Long ; 
  Account          = AccountFreeMargin();
  
  if (Lots_Long>=0.01)               
     {    
     ticket_long = OrderSend(Symbol(),OP_BUY,Lots_Long,Ask,NULL,Stop_Long,NULL,"R2D2 Long",6,0,Green) ;    
                           
     if(ticket_long>0) 
       { 
       if(OrderSelect(ticket_long,SELECT_BY_TICKET,MODE_TRADES))
         {
         Print("1%  ", AccountFreeMargin()*Risk) ;
         Perdita_Long = OrderOpenPrice()-Stop_Long ;
         Print("Loss Potenziale  ", Perdita_Long*Punto()/10," pips");
         Print("Perdita potenziale  : ", ( Perdita_Long*Punto()*Lots_Long)/MarketInfo("EURUSD",MODE_ASK)," Euro"); 
         Print("Perdita potenziale  : ", ((Perdita_Long*Punto()*Lots_Long)/Account*100)/MarketInfo("EURUSD",MODE_ASK),"% del conto"); 
         Print("Take Profit Long  : ", Take_Profit_Long);
                                 
         can_trade_long_2 = false;
         Barre = Bars ;
         Apertura = Open[0];
               
         int handle_6=FileOpen("Trend.csv", FILE_CSV|FILE_READ|FILE_WRITE, ';');
         if(handle_6>0)
           {
           FileSeek(handle_6, 0, SEEK_END);
           //---- add data to the end of file
           FileWrite(handle_6,OrderSymbol(),TimeToStr(OrderOpenTime()),Stop_Long);
           FileClose(handle_6);
           handle_6=0;
           }
         }
       else Print("Error opening BUY order: ",GetLastError()); 
       return(0); 
       }               
     }
  else if (a == 0)
     {
     Print("No trade man!");
     a = 1;
     Apertura = Open[0];
     }
  }

// POSIZIONI SHORT CON TAKE PROFIT
 
 
if(Entry_Short_2 && can_trade_short_1 && HOUR()==1)  
  {    
  Spread            = Ask - Bid ;
  Min_Stop          = Bid+MarketInfo(Symbol(),MODE_STOPLEVEL)/Punto() + Spread ;
  Stop_Short        = MathMax(High[0],High[1])+Filter_Out/Punto()+Spread  ;
  Distanza_Short    = Stop_Short - Bid ;
  Take_Profit_Short = Bid-(Distanza_Short*Ratio) ;    
  Lots_Short        = Lots_Short_Euro();  
  Initial_Size      = Lots_Short ; 
  Account           = AccountFreeMargin();                  
  
  if (Lots_Short>=0.01)                
     { 
     ticket_short = OrderSend(Symbol(),OP_SELL,Lots_Short,Bid,NULL,Stop_Short,Take_Profit_Short,"R2D2 Short",7,0,Red) ;                           
     
     if(ticket_short>0) 
       { 
       if(OrderSelect(ticket_short,SELECT_BY_TICKET,MODE_TRADES))
       {
       Print("1%  ", AccountFreeMargin()*Risk);
       Perdita_Short = Stop_Short-OrderOpenPrice() ;
       Print("Loss Potenziale  ", Perdita_Short*Punto()/10," pips");
       Print("Perdita potenziale  : ", ( Perdita_Short*Punto()*Lots_Short)/MarketInfo("EURUSD",MODE_BID)," Euro");
       Print("Perdita potenziale  : ", ((Perdita_Short*Punto()*Lots_Short)/Account*100)/MarketInfo("EURUSD",MODE_BID),"% del conto");
       Print("Take Profit Short  : ", Take_Profit_Short);
              
       can_trade_short_1 = false;
       Barre = Bars ;
       Apertura = Open[0];
       
       int handle_7=FileOpen("Trend.csv", FILE_CSV|FILE_READ|FILE_WRITE, ';');
       if(handle_7>0)
           {
           FileSeek(handle_7, 0, SEEK_END);
           //---- add data to the end of file
           FileWrite(handle_7,OrderSymbol(),TimeToStr(OrderOpenTime()),Stop_Short);
           FileClose(handle_7);
           handle_7=0;
           }    
     
       }
       else Print("Error opening SELL order : ",GetLastError()); 
       return(0); 
       }
     }  
  else if (a == 0)
     {
     Print("No trade man!");
     a = 1;
     Apertura = Open[0];
     }
  }
  

// POSIZIONI SHORT SENZA TAKE PROFIT
 
 
if(Entry_Short_2 && can_trade_short_2 && HOUR()==1)  
  {    
  Spread            = Ask - Bid ;
  Min_Stop          = Bid+MarketInfo(Symbol(),MODE_STOPLEVEL)/Punto() + Spread ;
  Stop_Short        = MathMax(High[0],High[1])+Filter_Out/Punto()+Spread  ;
  Distanza_Short    = Stop_Short - Bid ;
  Take_Profit_Short = Bid-(Distanza_Short*Ratio) ;    
  Lots_Short        = Lots_Short_Euro();  
  Initial_Size      = Lots_Short ; 
  Account           = AccountFreeMargin();                 
  
  if (Lots_Short>=0.01)                
     { 
     ticket_short = OrderSend(Symbol(),OP_SELL,Lots_Short,Bid,NULL,Stop_Short,NULL,"R2D2 Short",8,0,Red) ;                         
     
     if(ticket_short>0) 
       { 
       if(OrderSelect(ticket_short,SELECT_BY_TICKET,MODE_TRADES))
       {
       Print("1%  ", AccountFreeMargin()*Risk);
       Perdita_Short = Stop_Short-OrderOpenPrice() ;
       Print("Loss Potenziale  ", Perdita_Short*Punto()/10," pips");
       Print("Perdita potenziale  : ", ( Perdita_Short*Punto()*Lots_Short)/MarketInfo("EURUSD",MODE_BID)," Euro");
       Print("Perdita potenziale  : ", ((Perdita_Short*Punto()*Lots_Short)/Account*100)/MarketInfo("EURUSD",MODE_BID),"% del conto");
       Print("Take Profit Short  : ", Take_Profit_Short);
              
       can_trade_short_2 = false;
       Barre = Bars ;
       Apertura = Open[0];
       
       int handle_8=FileOpen("Trend.csv", FILE_CSV|FILE_READ|FILE_WRITE, ';');
       if(handle_8>0)
           {
           FileSeek(handle_8, 0, SEEK_END);
           //---- add data to the end of file
           FileWrite(handle_8,OrderSymbol(),TimeToStr(OrderOpenTime()),Stop_Short);
           FileClose(handle_8);
           handle_8=0;
           }    
     
       }
       else Print("Error opening SELL order : ",GetLastError()); 
       return(0); 
       }
     }  
  else if (a == 0)
     {
     Print("No trade man!");
     a = 1;
     Apertura = Open[0];
     }
  }
  
  

//+------------------------------------------------------------------+ 
//| RETRACE - SET UP POSIZIONI                                       |                                             
//+------------------------------------------------------------------+ 

bool Price_Action_Long  = Close[1]>Open[1] && Close[2]>Open[2] && Close[3]>Open[3] && Low[0]<Open[1] && Bid>=High[1]+Filter_In/Punto() ;

bool Price_Action_Short = Close[1]<Open[1] && Close[2]<Open[2] && Close[3]<Open[3] && High[0]>Open[1] && Bid<=Low[1]-Filter_In/Punto() ;

Entry_Long  = Price_Action_Long ;
  
Entry_Short = Price_Action_Short  ;  


//+------------------------------------------------------------------+ 
//| APERTURA POSIZIONI                                               |                                             
//+------------------------------------------------------------------+


// POSIZIONI LONG CON TAKE PROFIT

if(Entry_Long && can_trade_long_1 && HOUR()==1)  
  { 
  Min_Stop         = Bid-MarketInfo(Symbol(),MODE_STOPLEVEL)/Punto() ;
  Stop_Long        = Open[1]-Filter_Out/Punto() ;
  Distanza_Long    = Ask - Stop_Long ; 
  Take_Profit_Long = Ask + (Distanza_Long*Ratio) ;
    
  Lots_Long        = Lots_Long_Euro();
  Initial_Size     = Lots_Long ; 
  Account          = AccountFreeMargin();
  
  if (Lots_Long>=0.01)               
     {    
     ticket_long = OrderSend(Symbol(),OP_BUY,Lots_Long,Ask,NULL,Stop_Long,Take_Profit_Long,"Retrace Long",9,0,Green) ;       
                           
     if(ticket_long>0) 
       { 
       if(OrderSelect(ticket_long,SELECT_BY_TICKET,MODE_TRADES))
         {
         Print("1%  ", AccountFreeMargin()*Risk/100) ;
         Perdita_Long = OrderOpenPrice()-Stop_Long ;
         Print("Loss Potenziale  ", Perdita_Long*Punto()/10," pips");
         Print("Perdita potenziale  : ", ( Perdita_Long*Punto()*Lots_Long)/MarketInfo("EURUSD",MODE_ASK)," Euro"); 
         Print("Perdita potenziale  : ", ((Perdita_Long*Punto()*Lots_Long)/Account*100)/MarketInfo("EURUSD",MODE_ASK),"% del conto"); 
         Print("Take Profit Long  : ", Take_Profit_Long);
                          
         can_trade_long_1 = false;
         Barre = Bars ;
         Apertura = Open[0];
               
         int handle_9=FileOpen("Trend.csv", FILE_CSV|FILE_READ|FILE_WRITE, ';');
         if(handle_9>0)
           {
           FileSeek(handle_9, 0, SEEK_END);
           //---- add data to the end of file
           FileWrite(handle_9,OrderSymbol(),TimeToStr(OrderOpenTime()),Stop_Long);
           FileClose(handle_9);
           handle_9=0;
           }
         }
       else Print("Error opening BUY order: ",GetLastError()); 
       return(0); 
       }               
     }
  else if (a == 0)
     {
     Print("No trade man!");
     a = 1;
     Apertura = Open[0];
     }
  }
  


// POSIZIONI LONG SENZA TAKE PROFIT

if(Entry_Long && can_trade_long_2 && HOUR()==1)  
  { 
  Min_Stop         = Bid-MarketInfo(Symbol(),MODE_STOPLEVEL)/Punto() ;
  Stop_Long        = Open[1]-Filter_Out/Punto() ;
  Distanza_Long    = Ask - Stop_Long ; 
  
  Lots_Long        = Lots_Long_Euro(); 
  Initial_Size     = Lots_Long ; 
  Account          = AccountFreeMargin();
  
  if (Lots_Long>=0.01)               
     {    
     ticket_long = OrderSend(Symbol(),OP_BUY,Lots_Long,Ask,NULL,Stop_Long,NULL,"Retrace Long",10,0,Green) ;    
                           
     if(ticket_long>0) 
       { 
       if(OrderSelect(ticket_long,SELECT_BY_TICKET,MODE_TRADES))
         {
         Print("1%  ", AccountFreeMargin()*Risk/100) ;
         Perdita_Long = OrderOpenPrice()-Stop_Long ;
         Print("Loss Potenziale  ", Perdita_Long*Punto()/10," pips");
         Print("Perdita potenziale  : ", ( Perdita_Long*Punto()*Lots_Long)/MarketInfo("EURUSD",MODE_ASK)," Euro"); 
         Print("Perdita potenziale  : ", ((Perdita_Long*Punto()*Lots_Long)/Account*100)/MarketInfo("EURUSD",MODE_ASK),"% del conto"); 
         Print("Take Profit Long  : ", Take_Profit_Long);
                          
         can_trade_long_2 = false;
         Barre = Bars ;
         Apertura = Open[0];
               
         int handle_10=FileOpen("Trend.csv", FILE_CSV|FILE_READ|FILE_WRITE, ';');
         if(handle_10>0)
           {
           FileSeek(handle_10, 0, SEEK_END);
           //---- add data to the end of file
           FileWrite(handle_10,OrderSymbol(),TimeToStr(OrderOpenTime()),Stop_Long);
           FileClose(handle_10);
           handle_10=0;
           }
         }
       else Print("Error opening BUY order: ",GetLastError()); 
       return(0); 
       }               
     }
  else if (a == 0)
     {
     Print("No trade man!");
     a = 1;
     Apertura = Open[0];
     }
  }

// POSIZIONI SHORT CON TAKE PROFIT
 
 
if(Entry_Short && can_trade_short_1 && HOUR()==1)  
  {    
  Spread            = Ask - Bid ;
  Min_Stop          = Bid+MarketInfo(Symbol(),MODE_STOPLEVEL)/Punto() + Spread ;
  Stop_Short        = Open[1]+Filter_Out/Punto()+Spread  ;
  Distanza_Short    = Stop_Short - Bid ;
  Take_Profit_Short = Bid-(Distanza_Short*Ratio) ;    
  Lots_Short        = Lots_Short_Euro();  
  Initial_Size      = Lots_Short ; 
  Account           = AccountFreeMargin();                  
  
  if (Lots_Short>=0.01)                
     { 
     ticket_short = OrderSend(Symbol(),OP_SELL,Lots_Short,Bid,NULL,Stop_Short,Take_Profit_Short,"Retrace Short",11,0,Red) ;                           
     
     if(ticket_short>0) 
       { 
       if(OrderSelect(ticket_short,SELECT_BY_TICKET,MODE_TRADES))
       {
       Print("1%  ", AccountFreeMargin()*Risk/100);
       Perdita_Short = Stop_Short-OrderOpenPrice() ;
       Print("Loss Potenziale  ", Perdita_Short*Punto()/10," pips");
       Print("Perdita potenziale  : ", ( Perdita_Short*Punto()*Lots_Short)/MarketInfo("EURUSD",MODE_BID)," Euro");
       Print("Perdita potenziale  : ", ((Perdita_Short*Punto()*Lots_Short)/Account*100)/MarketInfo("EURUSD",MODE_BID),"% del conto");
       Print("Take Profit Short  : ", Take_Profit_Short);
              
       can_trade_short_1 = false;
       Barre = Bars ;
       Apertura = Open[0];
       
       int handle_11=FileOpen("Trend.csv", FILE_CSV|FILE_READ|FILE_WRITE, ';');
       if(handle_11>0)
           {
           FileSeek(handle_11, 0, SEEK_END);
           //---- add data to the end of file
           FileWrite(handle_11,OrderSymbol(),TimeToStr(OrderOpenTime()),Stop_Short);
           FileClose(handle_11);
           handle_11=0;
           }    
     
       }
       else Print("Error opening SELL order : ",GetLastError()); 
       return(0); 
       }
     }  
  else if (a == 0)
     {
     Print("No trade man!");
     a = 1;
     Apertura = Open[0];
     }
  }
  

// POSIZIONI SHORT SENZA TAKE PROFIT
 
 
if(Entry_Short && can_trade_short_2 && HOUR()==1)  
  {    
  Spread            = Ask - Bid ;
  Min_Stop          = Bid+MarketInfo(Symbol(),MODE_STOPLEVEL)/Punto() + Spread ;
  Stop_Short        = Open[1]+Filter_Out/Punto()+Spread  ;
  Distanza_Short    = Stop_Short - Bid ;
  Take_Profit_Short = Bid-(Distanza_Short*Ratio) ;    
  Lots_Short        = Lots_Short_Euro();  
  Initial_Size      = Lots_Short ; 
  Account           = AccountFreeMargin();                 
  
  if (Lots_Short>=0.01)                
     { 
     ticket_short = OrderSend(Symbol(),OP_SELL,Lots_Short,Bid,NULL,Stop_Short,NULL,"Retrace Short",12,0,Red) ;                         
     
     if(ticket_short>0) 
       { 
       if(OrderSelect(ticket_short,SELECT_BY_TICKET,MODE_TRADES))
       {
       Print("1%  ", AccountFreeMargin()*Risk/100);
       Perdita_Short = Stop_Short-OrderOpenPrice() ;
       Print("Loss Potenziale  ", Perdita_Short*Punto()/10," pips");
       Print("Perdita potenziale  : ", ( Perdita_Short*Punto()*Lots_Short)/MarketInfo("EURUSD",MODE_BID)," Euro");
       Print("Perdita potenziale  : ", ((Perdita_Short*Punto()*Lots_Short)/Account*100)/MarketInfo("EURUSD",MODE_BID),"% del conto");
       Print("Take Profit Short  : ", Take_Profit_Short);
              
       can_trade_short_2 = false;
       Barre = Bars ;
       Apertura = Open[0];
       
       int handle_12=FileOpen("Trend.csv", FILE_CSV|FILE_READ|FILE_WRITE, ';');
       if(handle_12>0)
           {
           FileSeek(handle_12, 0, SEEK_END);
           //---- add data to the end of file
           FileWrite(handle_12,OrderSymbol(),TimeToStr(OrderOpenTime()),Stop_Short);
           FileClose(handle_12);
           handle_12=0;
           }    
     
       }
       else Print("Error opening SELL order : ",GetLastError()); 
       return(0); 
       }
     }  
  else if (a == 0)
     {
     Print("No trade man!");
     a = 1;
     Apertura = Open[0];
     }
  }
        
  
//+------------------------------------------------------------------+ 
//| TRAILING STOP MIN/MAX ULTIME 2 BARRE                             | 
//+------------------------------------------------------------------+ 


   for(cnt=0;cnt<total;cnt++)
     {
      OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
      if(OrderSymbol()==Symbol())  // SIMBOLO
        {
        if(OrderType()==OP_BUY)   // POSIZIONI LONG
          {
          // trailing stop  
          Min_Stop      = Bid-MarketInfo(Symbol(),MODE_STOPLEVEL)/Punto() ;
          Trailing_Stop = Low[iLowest(NULL,0,MODE_LOW,2,1)]-Filter_Out/Punto() ;
          Trailing_Stop = MathMin(Trailing_Stop,Min_Stop) ;
          
          if(Bars>Barre && Close[1]>Open[1] && OrderProfit()>0 && OrderStopLoss()<Trailing_Stop)
              {
              OrderModify(OrderTicket(),OrderOpenPrice(),Trailing_Stop,OrderTakeProfit(),0,Blue);
              } 
          }           
        else // POSIZIONI SHORT
          { 
          // trailing stop  
          Min_Stop      = Bid+MarketInfo(Symbol(),MODE_STOPLEVEL)/Punto() + Spread ;
          Trailing_Stop = High[iHighest(NULL,0,MODE_HIGH,2,1)]+Filter_Out/Punto() + Spread ;
          Trailing_Stop = MathMax(Trailing_Stop,Min_Stop) ;
          
          if(Bars>Barre && Close[1]<Open[1] && OrderProfit()>0 && OrderStopLoss()>Trailing_Stop)
            {
            OrderModify(OrderTicket(),OrderOpenPrice(),Trailing_Stop,OrderTakeProfit(),0,Blue);
            }           
                   
          }   // Chiude Short
          
        }    // Chiude Simbolo
     }      // Chiude Ciclo For


//+------------------------------------------------------------------+ 
//| CHIUSURA POSIZIONI SE RAGGIUNTO IL TARGET DAILY                  | 
//+------------------------------------------------------------------+ 



   for(cnt=0;cnt<total;cnt++)
     {
      OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
      if(OrderSymbol()==Symbol() && AccountEquity()>=GlobalVariableGet("Target_Account"))  // SIMBOLO
        {
        if(OrderType()==OP_BUY)   // POSIZIONI LONG
          {
          OrderClose(OrderTicket(),OrderLots(),Bid,NULL,PaleGoldenrod);    
          } 
                     
        else // POSIZIONI SHORT
          { 
          OrderClose(OrderTicket(),OrderLots(),Ask,NULL,PaleGoldenrod);   
          }           
        
        Print("Done for the day") ;
                           
        }   // Chiude Simbolo      
     }      // Chiude Ciclo For

//+------------------------------------------------------------------+ 
//| CHIUSURA POSIZIONI SE RAGGIUNTO IL TARGET WEEKLY                 | 
//+------------------------------------------------------------------+ 



   for(cnt=0;cnt<total;cnt++)
     {
      OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
      if(OrderSymbol()==Symbol() && AccountEquity()>=GlobalVariableGet("Weekly_Target_Account"))  // SIMBOLO
        {
        if(OrderType()==OP_BUY)   // POSIZIONI LONG
          {
          OrderClose(OrderTicket(),OrderLots(),Bid,NULL,PaleGoldenrod);    
          } 
                     
        else // POSIZIONI SHORT
          { 
          OrderClose(OrderTicket(),OrderLots(),Ask,NULL,PaleGoldenrod);   
          }           
        
        Print("Done for the day") ;
                           
        }   // Chiude Simbolo      
     }      // Chiude Ciclo For
     

//+------------------------------------------------------------------+ 
//| CHIUSURA POSIZIONI RESIDUE IN APERTURA SESSIONE                  | 
//+------------------------------------------------------------------+ 



//   for(cnt=0;cnt<total;cnt++)
//     {
//      OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
//      if(OrderSymbol()==Symbol() && Hour()==9)  // SIMBOLO
//        {
//        if(OrderType()==OP_BUY)   // POSIZIONI LONG
//          {
//          OrderClose(OrderTicket(),OrderLots(),Bid,NULL,PaleGoldenrod);    
//          } 
                     
//        else // POSIZIONI SHORT
//          { 
//          OrderClose(OrderTicket(),OrderLots(),Ask,NULL,PaleGoldenrod);   
//          }           
        
//        Print("Done for the day") ;
                           
//        }   // Chiude Simbolo      
//     }      // Chiude Ciclo For
      
       
} // Chiude Start